class PlusPetit {
  int [] t ;

  /************************************
   * constructeur 
   *
   * entrée :
   *   - n : taille du tableau
   *   - a, b : borne de l'intervalle des nombres 
   *************************************/  
  PlusPetit(int n, int a, int b) {
    t = new int[n];
    
    for(int i = 0; i < n; i++)
      t[i] = int(random(a,b));
  }
  
  /************************************
   * calcule l'indice du minimum du tableau 
   *
   * entrée :
   *   - aucune
   *
   * sortie :
   *   - indice du minimum
   *************************************/  
  int indiceMin() {
    int m = t[0];
    int ind = 0;
    
    for(int i = 1; i < t.length; i++)
      if (t[i] < m) {
        m   = t[i];
        ind = i;
      }
      
    return ind;
  }
  
  /************************************
   *  calcule le nombre d'occurence du minimum
   *
   * entrée :
   *   - aucune
   *
   * sortie :
   *   - nombre d'occurrence du minimum
   *************************************/  
  int nbMin() {
    int m = t[0];
    int nb = 1;
    
    for(int i = 1; i < t.length; i++)
      if (t[i] < m) {
        m  = t[i];
        nb = 1;
      } else
        if (t[i] == m)
          nb++;
      
    return nb;    
  }
  
  /************************************
   *  place le minimum au début du tableau
   *
   * entrée :
   *   - aucune
   *
   * sortie :
   *   - aucune
   *************************************/  
  void minDebut() {
    int ind = indiceMin();
    permutte(0, ind);
  }
  
  /************************************
   *  permutation de nombre du tablea
   *
   * entrée :
   *   - i, j : indice des nombres à permutter
   *
   * sortie :
   *   - aucune
   *************************************/  
  void permutte(int i, int j) {
     int tmp  = t[i];
     t[i] = t[j];
     t[j] = tmp;
  }
  
  /************************************
   * chaine pour l'affichage du tableau 
   *
   * entrée :
   *   - aucune
   *
   * sortie :
   *   - chaine de caractères 
   *************************************/  
  public String toString() {
    String s = "";
    
    for(int i = 0; i < t.length; i++)
       s += t[i] + " ";
       
    return s;
  }
}

void setup() {
  PlusPetit tab = new PlusPetit(100, 0, 20);

  println(tab);
  
  println(tab.t[tab.indiceMin()]);
  println(tab.nbMin());  
  tab.minDebut();
  println(tab.t[0]);
}


