class De {
  int value ;
  
/************************************
 * constructeur de la valeur du dé 
 *
 * entrée :
 *  - aucune 
 *************************************/  
  De() {
    value = int(random(1, 7));
  }
  
/************************************
 * donne la valeur du dé 
 *
 * entrée :
 *  - aucune 
 *
 * sortie :
 *   - face supérieure
 *************************************/  
  int getValue() {
    return value;
  }
  
/************************************
 * donne la valeur du dé 
 *
 * entrée :
 *  - aucune 
 *
 * sortie :
 *   - aucune, état interne de l'objet modifiée
 *************************************/  
  void tirage() {
    value = int(random(1, 7));
  }
  
/************************************
 * donne la valeur du dé 
 *
 * entrée :
 *  - aucune 
 *
 * sortie :
 *   - string représentant le dé
 *************************************/  
  public String toString() {
    return "|" + value + "|";
  }
}

/************************************
 * tirage de n dés à 6 faces
 *
 * entrée :
 *  - n : nombre de tirage
 *
 * sortie :
 *   - tableau de dés
 *************************************/  
De [] tirageDe(int n) {
  De [] tabDes = new De[n];
  
  for(int i = 0; i < n; i++)
      tabDes[i] = new De();
      
  return tabDes;
}  

/************************************
 * affichage d'un tableau de dés
 *
 * entrée :
 *  - des : tableau à afficher
 *
 * sortie :
 *   - aucune, seulement affichage
 *************************************/  
void affiche(De [] des) {
  String s = "";
  
  for(int i = 0; i < des.length; i++)
     s += des[i];
     
  print(s);
}  

/************************************
 * frequence d'apparition de chaque face
 *
 * entrée :
 *  - des : tableau de dés
 *
 * sortie :
 *   - tableau contenant les fréquences
 *************************************/  
float [] frequence(De [] des) {
  float [] freq = new float[7];
  
  for(int i = 0; i < 7; i++)
    freq[i] = 0;
   
  for(int i = 0; i < des.length; i++)
    freq[des[i].getValue()] += 1;
 
  for(int i = 0; i < 7; i++)
    freq[i] /= des.length;
   
  return freq;  
}  

  
void setup() {
  De [] des = tirageDe(30);
  
  affiche(des);
  println();

  float [] freq = frequence(des);
  for(int i = 1; i < 7; i++)
    print(freq[i] + " ");
}


